<?php
// $Id: mainmenu.php,v 1.17 2003/10/17 05:20:27 eddieajau Exp $
/**
* Mainmenu code
* @package Mambo Open Source
* @Copyright (C) 2000 - 2003 Miro International Pty Ltd
* @ All rights reserved
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.17 $
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

// $module is defined in the calling function
if ($module->showtitle) {
?>
	<table width="95%" border="0" cellspacing="0" cellpadding="1" align="center">
		<tr>
			<td valign="top" class="moduleheading">&nbsp;<?php print $module->title;?></td>
		</tr>
	</table>
<?php
}

showMenu();

function showMenu() {
	global $database, $my, $cur_template;
	global $mosConfig_absolute_path;

	$Itemid = mosgetParam( $_REQUEST, 'Itemid', 0 );

	$database->setQuery( "SELECT m.* FROM #__menu AS m"
	. "\nWHERE menutype='mainmenu' AND published='1' AND access <= '$my->gid'"
	. "\nORDER BY parent,ordering"
	);

	$rows = $database->loadObjectList( 'id' );
	echo $database->getErrorMsg();

	// TODO: One day this should be user configurable
	if (file_exists( "$mosConfig_absolute_path/templates/$cur_template/images/indent1.png" )) {
		$imgpath = "templates/$cur_template/images";
	} else {
		$imgpath = "images/M_images";
	}
	$indents = array(
	// block prefix / item prefix / item suffix / block suffix
	array( "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"1\">", "<tr align=\"left\"><td>&nbsp;" , "</td></tr>", "</table>" ),
	array( "", "<br /><img src=\"images/M_images/blank.png\" alt=\"\" height=\"12\" width=\"4\" /><img src=\"$imgpath/indent1.png\" alt=\"\" />&nbsp;", "", "" ),
	array( "", "<br /><img src=\"images/M_images/blank.png\" alt=\"\" height=\"12\" width=\"8\" /><img src=\"$imgpath/indent2.png\" alt=\"indent\" />&nbsp;", "", "" ),
	array( "", "<br /><img src=\"images/M_images/blank.png\" alt=\"\" height=\"12\" width=\"12\" /><img src=\"$imgpath/indent3.png\" alt=\"indent\" />&nbsp;", "", "" ),
	array( "", "<br /><img src=\"images/M_images/blank.png\" alt=\"\" height=\"12\" width=\"16\" /><img src=\"$imgpath/indent4.png\" alt=\"indent\" />&nbsp;", "", "" ),
	array( "", "<br /><img src=\"images/M_images/blank.png\" alt=\"\" height=\"12\" width=\"20\" /><img src=\"$imgpath/indent5.png\" alt=\"indent\" />&nbsp;", "", "" ),
	array( "", "<br /><img src=\"images/M_images/blank.png\" alt=\"\" height=\"12\" width=\"24\" /><img src=\"$imgpath/indent.png\" alt=\"indent\" />&nbsp;", "", "" )
	);

	// establish the hierarchy of the menu
	$children = array();
	// first pass - collect children
	foreach ($rows as $v ) {
		$pt = $v->parent;
		$list = @$children[$pt] ? $children[$pt] : array();
		array_push( $list, $v );
		$children[$pt] = $list;
	}

	// second pass - collect 'open' menus
	$open = array( $Itemid );
	$count = 20; // maximum levels - to prevent runaway loop
	$id = $Itemid;
	while (--$count) {
		if (isset($rows[$id]) && $rows[$id]->parent > 0) {
			$id = $rows[$id]->parent;
			$open[] = $id;
		} else {
			break;
		}
	}
	recurseMenu( 0, 0, $children, $open, $indents );
	echo "<br />\n";

}

function recurseMenu( $id, $level, &$children, &$open, &$indents ) {
	if (@$children[$id]) {
		$n = min( $level, count( $indents )-1 );

		echo "\n".$indents[$n][0];
		foreach ($children[$id] as $row) {

			echo "\n".$indents[$n][1];

			if ($row->type != 'url' && $row->type != 'separator') {
				$row->link .= "&Itemid=$row->id";
			}
			$row->link = str_replace( '&', '&amp;', $row->link );

			$menuclass = 'mainlevel';
			if ($level > 0) {
				$menuclass = 'sublevel';
			}

			switch ($row->browserNav) {
				// cases are slightly different
				case 1:
				// open in a new window
				echo "<a href=\"$row->link\" target=\"_window\" class=\"$menuclass\">$row->name</a>\n";
				break;

				case 2:
				// open in a popup window
				echo "<a href=\"#\" onClick=\"javascript: window.open('$row->link', '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550');\" class=\"$menuclass\">$row->name</a>\n";
				break;

				case 3:
				// don't link it
				echo "$row->name\n";
				break;

				default:	// formerly case 2
				// open in parent window
				echo "<a href=\"$row->link\" class=\"$menuclass\">$row->name</a>\n";
				break;
			}
			if (in_array( $row->id, $open )) {
				recurseMenu( $row->id, $level+1, $children, $open, $indents );
			}

			echo $indents[$n][2];
		}
		echo "\n".$indents[$n][3];
	}
}
?>